VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Growl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private WithEvents GrowlSender As Growl_COM.Connector
Attribute GrowlSender.VB_VarHelpID = -1
Public Event CallbackReceived(ByVal CallbackData As Growl_COM.CallbackData)
Public Event OKReceived()
Public Event ErrorReceived(ByVal error As Growl_COM.error)

Public WarningNotification As Growl_COM.NotificationType
Public InformationNotification As Growl_COM.NotificationType

'internal class events
Private Sub Class_Initialize()
    'On Error Resume Next

    'configure the GrowlSender
    Set GrowlSender = New Growl_COM.Connector
    Call GrowlSender.ConfigureLocal("")
    'Call GrowlSender.ConfigureRemote("localhost", 23053, "secret")
    
    'set up the notification types
    Set WarningNotification = New Growl_COM.NotificationType
    WarningNotification.Name = "Warning"
    WarningNotification.DisplayName = "Warning"
    WarningNotification.Enabled = True
    Set InformationNotification = New Growl_COM.NotificationType
    InformationNotification.Name = "Information"
    InformationNotification.DisplayName = "Information"
    InformationNotification.Enabled = False
End Sub

Private Sub Class_Terminate()
  On Error Resume Next
  
  Set GrowlSender = Nothing
End Sub

Public Sub Register()
    Dim notificationTypes(1) As Growl_COM.NotificationType
    Set notificationTypes(0) = WarningNotification
    Set notificationTypes(1) = InformationNotification
    
    Dim app As Application
    Set app = New Application
    app.Name = "VB Test App"
    
    Call GrowlSender.Register(app, notificationTypes)
End Sub

Public Sub Notify()
    Dim n As Notification
    Set n = New Notification
    n.ApplicationName = "VB Test App"
    n.ID = "1234567890"
    n.Sticky = True
    n.Title = "Notification From VB"
    n.Text = "This came from VB"
    n.Type = WarningNotification.Name
    
    Dim c As CallbackContext
    Set c = New CallbackContext
    c.Data = "my data"
    c.Type = "string"
    
    Call GrowlSender.Notify("VB Test App", n, c)
End Sub



Private Sub GrowlSender_CallbackReceived(ByVal cd As Growl_COM.CallbackData)
    Debug.Print (cd.Result)
    RaiseEvent CallbackReceived(cd)
End Sub

Private Sub GrowlSender_ErrorReceived(ByVal error As Growl_COM.error)
    Debug.Print (error.Code)
    Debug.Print (error.Description)
End Sub

Private Sub GrowlSender_OKReceived()
    Debug.Print ("OK")
End Sub
